SystemOrganization addCategory: #'Magritte-Seaside-Components'!
SystemOrganization addCategory: #'Magritte-Seaside-Report'!
SystemOrganization addCategory: #'Magritte-Seaside-Renderer'!
SystemOrganization addCategory: #'Magritte-Seaside-Examples'!

Object subclass: #MAColumn
	instanceVariableNames: 'report properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

MAColumn subclass: #MAActionColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MAActionColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 19:12'!
defaultTitle
	^String new.! !

!MAActionColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 15:46'!
defaultUseLinks
	^true! !

!MAActionColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 15:47'!
renderCellContent: anObject index: aNumber on: html
	self useLinks 
		ifTrue: [ self renderCellLinkContent: anObject index: aNumber on: html ]
		ifFalse: [ self renderCellFormContent: anObject index: aNumber on: html ].! !

!MAActionColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 15:47'!
renderCellFormContent: anObject index: aNumber on: html
	self subclassResponsibility.! !

!MAActionColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 15:47'!
renderCellLinkContent: anObject index: aNumber on: html
	self subclassResponsibility.! !

!MAActionColumn methodsFor: 'accessing' stamp: 'lr 3/21/2005 16:12'!
useLinks
	^self propertyAt: #useLinks ifAbsent: [ self defaultUseLinks ].! !

!MAActionColumn methodsFor: 'accessing' stamp: 'lr 3/21/2005 15:46'!
useLinks: aBoolean
	self propertyAt: #useLinks put: aBoolean.! !

MAActionColumn subclass: #MACommandColumn
	instanceVariableNames: 'commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MACommandColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 16:19'!
addCommand: aBlock text: aString
	self commands add: aBlock -> aString.! !

!MACommandColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 19:11'!
addCommandOn: anObject selector: aSelector text: aString
	self addCommand: (MessageSend receiver: anObject selector: aSelector) text: aString.! !

!MACommandColumn methodsFor: 'accessing' stamp: 'lr 3/21/2005 16:19'!
commands
	^commands! !

!MACommandColumn methodsFor: 'accessing' stamp: 'lr 3/21/2005 16:19'!
commands: aCollection
	commands := aCollection! !

!MACommandColumn methodsFor: 'initialization' stamp: 'lr 3/21/2005 16:18'!
initialize
	super initialize.
	self commands: OrderedCollection new.! !

!MACommandColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 16:17'!
renderCellFormContent: anObject index: aNumber on: html
	self commands
		do: [ :each |
			html
				submitButtonWithAction: [ each key value: anObject ] 
				text: each value ]
		separatedBy: [ html space ].! !

!MACommandColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 16:17'!
renderCellLinkContent: anObject index: aNumber on: html
	self commands
		do: [ :each | 
			html 
				anchorWithAction: [ each key value: anObject ] 
				text: each value ]
		separatedBy: [ html space ].! !

MAActionColumn subclass: #MASelectionColumn
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

MASelectionColumn subclass: #MACheckboxColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MACheckboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 15:58'!
defaultFormDeselected
	^ScriptingSystem formAtKey: #CheckBoxOff.! !

!MACheckboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 15:58'!
defaultFormSelected
	^ScriptingSystem formAtKey: #CheckBoxOn.! !

!MACheckboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 15:58'!
defaultSelection
	^Set new.! !

!MACheckboxColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 15:55'!
deselect: anObject
	self selection remove: anObject ifAbsent: nil.! !

!MACheckboxColumn methodsFor: 'testing' stamp: 'lr 3/21/2005 15:53'!
isSelected: anObject
	^self selection includes: anObject.! !

!MACheckboxColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 20:52'!
renderCellFormContent: anObject index: aNumber on: html
	html 
		checkboxWithValue: (self isSelected: anObject) 
		callback: [ :value | self select: anObject value: value ].! !

!MACheckboxColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 15:55'!
select: anObject
	self selection add: anObject.! !

MASelectionColumn subclass: #MAOptionboxColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MAOptionboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:01'!
defaultFormDeselected
	^ScriptingSystem formDictionary  formAtKey: #RadioButtonOff.! !

!MAOptionboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:01'!
defaultFormSelected
	^ScriptingSystem formAtKey: #RadioButtonOn.! !

!MAOptionboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 15:56'!
defaultSelection
	^nil! !

!MAOptionboxColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 15:54'!
deselect: anObject
	self selection: nil.! !

!MAOptionboxColumn methodsFor: 'testing' stamp: 'lr 3/21/2005 15:54'!
isSelected: anObject
	^self selection == anObject.! !

!MAOptionboxColumn methodsFor: 'private' stamp: 'lr 3/21/2005 16:15'!
radioGroupFor: html
	"This is a very bad thing, you might never have seen in your own life. Very strange things might happen here, but for now it mostly does what we need."
	
	| renderer |
	renderer := self propertyAt: #radioGroupRenderer ifAbsentPut: nil.
	^renderer == html 
		ifTrue: [ self propertyAt: #radioGroupCallback ]
		ifFalse: [
			self propertyAt: #radioGroupRenderer put: html.
			self propertyAt: #radioGroupCallback put: html radioGroup ].! !

!MAOptionboxColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 16:04'!
renderCellFormContent: anObject index: aNumber on: html
	html
		radioButtonInGroup: (self radioGroupFor: html) 
		selected: (self isSelected: anObject) 
		callback: [ self select: anObject ].! !

!MAOptionboxColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 15:54'!
select: anObject
	self selection: anObject.! !

!MASelectionColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:01'!
defaultFormDeselected
	self subclassResponsibility.! !

!MASelectionColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:01'!
defaultFormSelected
	self subclassResponsibility.! !

!MASelectionColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 15:55'!
defaultSelection
	self subclassResponsibility.! !

!MASelectionColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 15:52'!
deselect: anObject
	self subclassResponsibility.! !

!MASelectionColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:12'!
formDeselected
	^self propertyAt: #formDeselected ifAbsent: [ self defaultFormDeselected ].! !

!MASelectionColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:02'!
formDeselected: aForm
	^self propertyAt: #formDeselected put: aForm.! !

!MASelectionColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:13'!
formSelected
	^self propertyAt: #formSelected ifAbsent: [ self defaultFormSelected ].! !

!MASelectionColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:01'!
formSelected: aForm
	^self propertyAt: #formSelected put: aForm.! !

!MASelectionColumn methodsFor: 'testing' stamp: 'lr 3/21/2005 15:53'!
isSelected: anObject
	self subclassResponsibility.! !

!MASelectionColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 15:55'!
refresh
	super refresh.
	self selection: self defaultSelection.! !

!MASelectionColumn methodsFor: 'rendering' stamp: 'lr 3/23/2005 00:35'!
renderCellLinkContent: anObject index: aNumber on: html
	| selected |
	selected := self isSelected: anObject.
	html
		anchorWithAction: [ self select: anObject value: selected not ]
		do: [ 
			html imageWithForm: (selected
				ifTrue: [ self formSelected ]
				ifFalse: [ self formDeselected ]) ].! !

!MASelectionColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 15:52'!
select: anObject
	self subclassResponsibility.! !

!MASelectionColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 20:51'!
select: anObject value: aBoolean
	aBoolean
		ifTrue: [ self select: anObject ]
		ifFalse: [ self deselect: anObject ].! !

!MASelectionColumn methodsFor: 'accessing' stamp: 'lr 3/23/2005 00:34'!
selection
	selection isNil
		ifTrue: [ self selection: self defaultSelection ].
	^selection! !

!MASelectionColumn methodsFor: 'accessing' stamp: 'lr 3/21/2005 15:48'!
selection: anObject
	selection := anObject! !

!MAColumn class methodsFor: 'accessing-description' stamp: 'lr 3/28/2005 12:24'!
descriptionComment
	^MAStringDescription selector: #comment label: 'Comment' priority: 200.! !

!MAColumn class methodsFor: 'accessing-description' stamp: 'lr 3/28/2005 12:24'!
descriptionTitle
	^MAStringDescription selector: #title label: 'Title' priority: 100.! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 18:04'!
cascade
	^self propertyAt: #cascade ifAbsent: [ self defaultCascade ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 17:36'!
cascade: anArray
	self propertyAt: #cascade put: anArray.! !

!MAColumn methodsFor: 'accessing' stamp: 'lr 3/21/2005 17:30'!
column
	^self report cache
		collect: [ :each | self valueFor: each ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/22/2005 23:33'!
comment
	^self propertyAt: #comment ifAbsent: [ self defaultComment ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/22/2005 23:33'!
comment: aString
	self propertyAt: #comment put: aString.! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 17:31'!
defaultCascade
	^ #( yourself )! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/23/2005 00:39'!
defaultComment
	^nil! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 17:31'!
defaultDownArrow
	^ScriptingSystem formAtKey: #DownArrow.! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 15:45'!
defaultFooter
	^nil! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 17:31'!
defaultFormat
	^MessageSend receiver: self selector: #renderCellContent:index:on:.! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 15:45'!
defaultSorter
	^[ :a :b | a < b ]! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 17:31'!
defaultTitle
	^self cascade first asCapitalizedPhrase.! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 17:31'!
defaultUpArrow
	^ScriptingSystem formAtKey: #UpArrow.! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/23/2005 00:36'!
defaultVisible
	^true! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 18:04'!
footer
	^self propertyAt: #footer ifAbsent: [ self defaultFooter ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 17:29'!
footer: aBlock
	self propertyAt: #footer put: aBlock.! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 18:04'!
format
	^self propertyAt: #format ifAbsent: [ self defaultFormat ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 17:29'!
format: aBlock
	self propertyAt: #format put: aBlock.! !

!MAColumn methodsFor: 'accessing' stamp: 'lr 3/21/2005 17:30'!
index
	^self report columns indexOf: self.! !

!MAColumn methodsFor: 'initialization' stamp: 'lr 3/21/2005 15:39'!
initialize
	super initialize.
	properties := Dictionary new.! !

!MAColumn methodsFor: 'testing' stamp: 'lr 3/21/2005 17:33'!
isReversed
	^self report sortReversed.! !

!MAColumn methodsFor: 'testing' stamp: 'lr 3/21/2005 17:33'!
isSortable
	^self report sortEnabled 
		and: [ self sorter notNil ].! !

!MAColumn methodsFor: 'testing' stamp: 'lr 3/21/2005 17:33'!
isSorted
	^self report sortColumn = self.! !

!MAColumn methodsFor: 'testing' stamp: 'lr 3/23/2005 00:38'!
isVisible
	^self visible.! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 15:41'!
properties
	^properties! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 16:13'!
propertyAt: aSymbol
	^self properties at: aSymbol.! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 16:13'!
propertyAt: aSymbol ifAbsent: aBlock
	^self properties at: aSymbol ifAbsent: aBlock.! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 16:12'!
propertyAt: aSymbol ifAbsentPut: aBlock
	^self properties at: aSymbol ifAbsentPut: aBlock.! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 15:41'!
propertyAt: aSymbol put: anObject
	^self properties at: aSymbol put: anObject.! !

!MAColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 15:42'!
refresh! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 3/23/2005 00:47'!
renderCell: anObject index: aNumber on: html
	html tableData: [
		self format in: [ :format |
			format numArgs caseOf: {
				[ 1 ] -> [ html render: (format value: anObject) ].
				[ 2 ] -> [ format valueWithArguments: (Array with: anObject with: html) ].
				[ 3 ] -> [ format valueWithArguments: (Array with: anObject with: aNumber with: html) ].
			} otherwise: [ self error: 'Invalid renderer block' ] ] ].! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 17:32'!
renderCellContent: anObject index: aNumber on: html
	html render: anObject.! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 17:33'!
renderFootCellOn: html
	html tableData: [ self renderFootContentOn: html ].! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 17:33'!
renderFootContentOn: html
	self footer isNil
		ifFalse: [ html render: self footer ].! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 3/23/2005 00:47'!
renderHeadCellOn: html
	self comment isEmptyOrNil
		ifFalse: [ html attributeAt: 'title' put: self comment ].
	html tableData: [ 
		self isSortable
			ifFalse: [ self renderHeadContentOn: html ]
			ifTrue: [
				html
					anchorWithCallback: [ self report sort: self ]
					do: [ 
						self renderHeadContentOn: html.
						self renderHeadSorterOn: html ] ] ].! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 17:33'!
renderHeadContentOn: html
	html render: self title.! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 17:33'!
renderHeadSorterOn: html
	self isSorted ifTrue: [
		html imageWithForm: (self isReversed 
			ifTrue: [ self report sortArrowUp ]
			ifFalse: [ self report sortArrowDown ]) ].! !

!MAColumn methodsFor: 'accessing' stamp: 'lr 3/21/2005 17:30'!
report
	^report! !

!MAColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 17:34'!
selector: aSymbol
	self cascade: (Array with: aSymbol).! !

!MAColumn methodsFor: 'initialization' stamp: 'lr 3/21/2005 15:40'!
setReport: aReport
	report := aReport.! !

!MAColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 19:50'!
sortRows: aCollection
	| result |
	result := SortedCollection new: aCollection size.
	result 
		sortBlock: [ :a :b | 
			[ (self valueFor: a) < (self valueFor: b) ]
				ifError: [ false ] ];
		addAll: aCollection.
	^self isReversed
		ifFalse: [ result ]
		ifTrue: [ result reversed ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 18:04'!
sorter
	^self propertyAt: #sorter ifAbsent: [ self defaultSorter ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 17:29'!
sorter: aBlock
	self propertyAt: #sorter put: aBlock.! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 18:04'!
title
	^self propertyAt: #title ifAbsent: [ self defaultTitle ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 17:29'!
title: aString
	self propertyAt: #title put: aString.! !

!MAColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 17:32'!
valueFor: aRow
	^self cascade
		inject: aRow
		into: [ :result :each | result perform: each ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/23/2005 00:37'!
visible
	^self propertyAt: #visible ifAbsent: [ self defaultVisible ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/23/2005 00:36'!
visible: aBoolean
	self propertyAt: #visible put: aBoolean.! !

MAColumn subclass: #MADescribedColumn
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MADescribedColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 17:39'!
defaultCascade
	self shouldNotImplement.! !

!MADescribedColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 18:05'!
defaultSorter
	^(self description comparators includes: MAComparator lessThan)
		ifTrue: [ super defaultSorter ].! !

!MADescribedColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 17:37'!
defaultTitle
	^self description label.! !

!MADescribedColumn methodsFor: 'accessing' stamp: 'lr 3/21/2005 17:34'!
description
	^description! !

!MADescribedColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 17:48'!
renderCellContent: anObject index: aNumber on: html
	html render: (self description toString: anObject).! !

!MADescribedColumn methodsFor: 'initialization' stamp: 'lr 3/21/2005 17:35'!
setDescription: aDescription
	description := aDescription! !

!MADescribedColumn methodsFor: 'actions' stamp: 'lr 3/30/2005 16:28'!
valueFor: aRow
	^self description accessor read: aRow.! !

!Object methodsFor: '*Magritte-Seaside-converting' stamp: 'lr 3/30/2005 14:05'!
asComponent
	^self description asComponentOn: self.! !

!Object methodsFor: '*Magritte-Seaside-converting' stamp: 'lr 3/30/2005 16:30'!
asComponentWrapper: aWrapperClass
	^self description asComponentOn: self wrapper: aWrapperClass.! !

!Object methodsFor: '*Magritte-Seaside-converting' stamp: 'lr 3/30/2005 16:31'!
asComponentWrapper: aWrapperClass renderer: aRenderer
	^self description asComponentOn: self wrapper: aWrapperClass renderer: aRenderer.! !

!MATimeStampDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/11/2005 23:05'!
defaultComponentClass
	^MATimeStampInputComponent! !

!MADateDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:36'!
defaultComponentClass
	^MADateInputComponent! !

!MABinaryDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:35'!
defaultComponentClass
	^MAFileUploadComponent! !

MAVisitor subclass: #MARenderer
	instanceVariableNames: 'html component readonly'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderer'!

MARenderer subclass: #MACssRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderer'!

!MACssRenderer methodsFor: 'private' stamp: 'lr 3/14/2005 14:20'!
cssClass: aString modificators: aDescription
	^String streamContents: [ :stream |
		stream nextPutAll: aString.
		aDescription isReadonly
			ifTrue: [ stream space; nextPutAll: 'readonly' ].
		aDescription isRequired
			ifTrue: [ stream space; nextPutAll: 'required' ] ].! !

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 3/14/2005 14:23'!
renderEditor: aDescription
	html 
		divClass: 'editor'
		with: [ super renderEditor: aDescription ].! !

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 3/14/2005 14:23'!
renderLabel: aDescription
	html 
		divClass: 'label'
		with: [ super renderLabel: aDescription ].! !

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 3/14/2005 14:38'!
renderSpacer: aDescription
	html divClass: 'spacer' with: nil.! !

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 3/14/2005 14:23'!
renderViewer: aDescription
	html 
		divClass: 'viewer'
		with: [ super renderViewer: aDescription ].! !

!MACssRenderer methodsFor: 'visiting' stamp: 'lr 4/9/2005 15:41'!
visitContainer: aDescription
	html divClass: 'container' with: [ super visitContainer: aDescription ].! !

!MACssRenderer methodsFor: 'visiting' stamp: 'lr 4/9/2005 15:42'!
visitElement: aDescription
	self renderComment: aDescription.
	html 
		divClass: (self cssClass: 'element' modificators: aDescription)
		with: [ super visitElement: aDescription ].! !

!MARenderer class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 21:02'!
in: aComponent on: aRenderer
	^self new
		component: aComponent;
		html: aRenderer;
		yourself.! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:02'!
component
	^component! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:02'!
component: aComponent
	component := aComponent! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:02'!
html
	^html! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:02'!
html: aRenderer
	html := aRenderer! !

!MARenderer methodsFor: 'initilization' stamp: 'lr 3/10/2005 22:13'!
initialize
	super initialize.
	self readonly: false.! !

!MARenderer methodsFor: 'testing' stamp: 'lr 3/10/2005 21:18'!
isReadonly
	^self readonly.! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:17'!
readonly
	^readonly! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:17'!
readonly: aBoolean
	readonly := aBoolean! !

!MARenderer methodsFor: 'rendering' stamp: 'lr 3/23/2005 07:27'!
renderComment: aDescription
	aDescription hasComment
		ifTrue: [ html attributeAt: 'title' put: aDescription comment ].! !

!MARenderer methodsFor: 'rendering' stamp: 'lr 4/8/2005 11:08'!
renderEditor: aDescription
	aDescription autofocus
		ifFalse: [ self component renderEditorOn: html ]
		ifTrue: [
			html autofocus: [ 
				self component renderEditorOn: html ] ].! !

!MARenderer methodsFor: 'rendering' stamp: 'lr 3/13/2005 18:06'!
renderLabel: aDescription
	self component renderLabelOn: html.! !

!MARenderer methodsFor: 'rendering' stamp: 'lr 3/14/2005 14:37'!
renderSpacer: aDescription! !

!MARenderer methodsFor: 'rendering' stamp: 'lr 3/10/2005 21:17'!
renderViewer: aDescription
	self component renderViewerOn: html.! !

!MARenderer methodsFor: 'rendering' stamp: 'lr 3/10/2005 21:51'!
renderWidget: aDescription
	(self isReadonly or: [ aDescription isReadonly ])
		ifTrue: [ self renderViewer: aDescription ]
		ifFalse: [ self renderEditor: aDescription ].! !

!MARenderer methodsFor: 'visiting' stamp: 'lr 4/9/2005 15:40'!
visitContainer: aDescription
	self renderWidget: aDescription.! !

!MARenderer methodsFor: 'visiting' stamp: 'lr 4/9/2005 15:41'!
visitElement: aDescription
	self renderLabel: aDescription.
	self renderSpacer: aDescription.
	self renderWidget: aDescription.! !

MARenderer subclass: #MATableRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderer'!

!MATableRenderer methodsFor: 'rendering' stamp: 'lr 3/10/2005 21:22'!
renderLabel: aDescription
	html tableHeading: [ super renderLabel: aDescription ].! !

!MATableRenderer methodsFor: 'rendering' stamp: 'lr 3/10/2005 21:30'!
renderWidget: aDescription
	html tableData: [ super renderWidget: aDescription ].! !

!MATableRenderer methodsFor: 'visiting' stamp: 'lr 4/9/2005 15:42'!
visitContainer: aDescription
	html cssClass: 'form'.
	html table: [ super renderWidget: aDescription ].
! !

!MATableRenderer methodsFor: 'visiting' stamp: 'lr 4/9/2005 15:43'!
visitElement: aDescription
	self renderComment: aDescription.
	html tableRow: [ super visitElement: aDescription ].
! !

!MADescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 22:25'!
defaultComponentClass
	self subclassResponsibility! !

!MADescription methodsFor: '*Magritte-Seaside-converting' stamp: 'avi 3/30/2005 21:53'!
asComponentOn: anObject
	^self asComponentOn: anObject wrapper: anObject defaultWrapperClass.! !

!MADescription methodsFor: '*Magritte-Seaside-converting' stamp: 'lr 3/30/2005 15:57'!
asComponentOn: anObject wrapper: aWrapperClass
	^self asComponentOn: anObject wrapper: aWrapperClass renderer: MAComponent defaultRenderer.! !

!MADescription methodsFor: '*Magritte-Seaside-converting' stamp: 'lr 4/5/2005 11:07'!
asComponentOn: anObject wrapper: aWrapperClass renderer: aRenderer
	^self componentClass 
		wrapper: (aWrapperClass on: self model: anObject)
		renderer: aRenderer.! !

!MADescription methodsFor: '*Magritte-Seaside-accessing' stamp: 'lr 4/8/2005 10:58'!
autofocus
	^self propertyAt: #autofocus ifAbsent: [ false ].! !

!MADescription methodsFor: '*Magritte-Seaside-accessing' stamp: 'lr 4/8/2005 10:58'!
autofocus: aBoolean
	self propertyAt: #autofocus put: aBoolean.! !

!MADescription methodsFor: '*Magritte-Seaside-accessing' stamp: 'lr 3/10/2005 10:33'!
componentClass
	^self propertyAt: #componentClass ifAbsent: [ self class defaultComponentClass ].! !

!MADescription methodsFor: '*Magritte-Seaside-accessing' stamp: 'lr 3/10/2005 10:33'!
componentClass: aClass
	^self propertyAt: #componentClass put: aClass.! !

!MADurationDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/15/2005 21:49'!
defaultComponentClass
	^MADurationInputComponent! !

!MAElementDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:31'!
defaultAttributes
	^Dictionary new.! !

!MAElementDescription methodsFor: '*Magritte-Seaside' stamp: 'lr 3/29/2005 20:03'!
attributes
	^self propertyAt: #attributes ifAbsentPut: [ self class defaultAttributes ].! !

!MAElementDescription methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:33'!
attributes: aDictionary
	^self propertyAt: #attributes put: aDictionary.! !

!MABooleanDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 22:45'!
defaultComponentClass
	^MACheckboxComponent! !

WADecoration subclass: #MAComponentDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAComponentDecoration methodsFor: 'accessing' stamp: 'lr 4/4/2005 08:13'!
description
	^self component description.! !

!MAComponentDecoration methodsFor: 'accessing' stamp: 'lr 4/4/2005 08:13'!
renderer
	^self component renderer.! !

!MAComponentDecoration methodsFor: 'accessing' stamp: 'lr 4/4/2005 08:13'!
wrapper
	^self component wrapper.! !

MAComponentDecoration subclass: #MAFormDecoration
	instanceVariableNames: 'buttons default'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAFormDecoration class methodsFor: 'instance creation' stamp: 'lr 4/8/2005 10:15'!
buttons: aCollection
	^self new
		addButtons: aCollection;
		initializeDefault;
		yourself.! !

!MAFormDecoration methodsFor: 'actions' stamp: 'lr 4/8/2005 10:08'!
addButton: aSelector
	self addButton: aSelector label: (self labelForSelector: aSelector).! !

!MAFormDecoration methodsFor: 'actions' stamp: 'lr 4/8/2005 10:09'!
addButton: aSelector label: aString
	self buttons add: aSelector -> aString.! !

!MAFormDecoration methodsFor: 'actions' stamp: 'lr 4/8/2005 10:14'!
addButtons: aCollection
	aCollection do: [ :each |
		each isVariableBinding 
			ifFalse: [ self addButton: each ]
			ifTrue: [ self addButton: each key label: each value ] ].! !

!MAFormDecoration methodsFor: 'accessing' stamp: 'lr 4/4/2005 08:21'!
buttons
	^buttons! !

!MAFormDecoration methodsFor: 'accessing' stamp: 'lr 4/4/2005 08:21'!
buttons: aCollection
	buttons := aCollection! !

!MAFormDecoration methodsFor: 'accessing' stamp: 'lr 4/4/2005 08:21'!
default
	^default! !

!MAFormDecoration methodsFor: 'accessing' stamp: 'lr 4/4/2005 08:21'!
default: aSelector
	default := aSelector.! !

!MAFormDecoration methodsFor: 'testing' stamp: 'lr 4/4/2005 08:42'!
hasDefaultAction
	^self default notNil.! !

!MAFormDecoration methodsFor: 'testing' stamp: 'lr 4/4/2005 08:42'!
hasMultipartData
	^self component hasMultipartData.! !

!MAFormDecoration methodsFor: 'initialization' stamp: 'lr 4/8/2005 10:12'!
initialize
	super initialize.
	self buttons: OrderedCollection new.! !

!MAFormDecoration methodsFor: 'initialization' stamp: 'lr 4/8/2005 10:16'!
initializeDefault
	self buttons isEmpty 
		ifFalse: [ self default: self buttons first key ].! !

!MAFormDecoration methodsFor: 'rendering' stamp: 'lr 4/8/2005 10:10'!
renderButtonsOn: html
	self buttons do: [ :each | 
		(self hasDefaultAction and: [ self default = each ])
			ifTrue: [ html cssClass: 'default' ].
		html 
			submitButtonWithAction: (MessageSend
				receiver: self component
				selector: each key)
			text: each value ].! !

!MAFormDecoration methodsFor: 'rendering' stamp: 'lr 4/4/2005 08:42'!
renderContentOn: html
	self hasMultipartData 
		ifTrue: [ html attributeAt: 'enctype' put: 'multipart/form-data' ].
	html form: [
		self hasDefaultAction 
			ifTrue: [ self renderDefaultOn: html ].
		self renderOwnerOn: html.
		html
			divClass: 'buttons' 
			with: [ self renderButtonsOn: html ] ].! !

!MAFormDecoration methodsFor: 'rendering' stamp: 'lr 4/8/2005 10:10'!
renderDefaultOn: html
	html attributes value: String new; width: 0; size: 0.
	html 
		submitButtonWithAction: (MessageSend
			receiver: self component
			selector: self default) 
		image: html transparent1X1Form.! !

MAComponentDecoration subclass: #MAValidationDecoration
	instanceVariableNames: 'exceptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAValidationDecoration methodsFor: 'accessing-configuration' stamp: 'lr 4/5/2005 13:16'!
defaultExceptionSet
	^MAError! !

!MAValidationDecoration methodsFor: 'accessing' stamp: 'lr 3/13/2005 17:50'!
exceptions
	^exceptions! !

!MAValidationDecoration methodsFor: 'accessing' stamp: 'lr 3/11/2005 17:17'!
exceptions: aCollection
	exceptions := aCollection! !

!MAValidationDecoration methodsFor: 'testing' stamp: 'lr 4/3/2005 12:35'!
hasDebugging
	^(self session application preferenceAt: #deploymentMode) not.! !

!MAValidationDecoration methodsFor: 'testing' stamp: 'lr 3/13/2005 20:05'!
hasExceptions
	^self exceptions isEmptyOrNil not.! !

!MAValidationDecoration methodsFor: 'initialization' stamp: 'lr 3/14/2005 16:53'!
initialize
	super initialize.
	self exceptions: Array new.! !

!MAValidationDecoration methodsFor: 'private' stamp: 'lr 3/13/2005 17:48'!
processChildCallbacks: aStream
	self wrapInValidationHandlerDo: [ super processChildCallbacks: aStream ].! !

!MAValidationDecoration methodsFor: 'rendering' stamp: 'lr 3/14/2005 16:46'!
renderContentOn: html
	self hasExceptions
		ifTrue: [ self renderExceptionsOn: html ].
	self renderOwnerOn: html.! !

!MAValidationDecoration methodsFor: 'rendering' stamp: 'lr 4/3/2005 12:41'!
renderExceptionsOn: html
	html divClass: 'exceptions' with: [
		self exceptions do: [ :each |
			html 
				divClass: 'exception' 
				with: each messageText ] ].
	self exceptions: Array new.! !

!MAValidationDecoration methodsFor: 'private' stamp: 'lr 4/9/2005 15:50'!
wrapInValidationHandlerDo: aBlock
	aBlock
		on: self defaultExceptionSet
		do: [ :error | 
			self exceptions: (self exceptions copyWith: error).
			error isResumable ifTrue: [ error resume ] ].! !

!MATimeDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:37'!
defaultComponentClass
	^MATimeInputComponent! !

!MAContainer class methodsFor: '*Magritte-Seaside' stamp: 'lr 4/7/2005 19:21'!
defaultComponentClass
	^MAContainerComponent! !

!MANumberDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:36'!
defaultComponentClass
	^MATextInputComponent! !

WAComponent subclass: #MAComponent
	instanceVariableNames: 'wrapper renderer parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAComponent class methodsFor: 'accessing-defaults' stamp: 'lr 3/14/2005 17:02'!
defaultRenderer
	^MATableRenderer new.! !

!MAComponent class methodsFor: 'instance creation' stamp: 'lr 3/30/2005 14:54'!
wrapper: aWrapper
	^self wrapper: aWrapper renderer: self defaultRenderer.! !

!MAComponent class methodsFor: 'instance creation' stamp: 'lr 3/30/2005 14:55'!
wrapper: aWrapper renderer: aRenderer
	^self new
		setWrapper: aWrapper;
		setRenderer: aRenderer;
		yourself.! !

!MAComponent methodsFor: 'forms' stamp: 'lr 2/28/2005 16:14'!
addForm
	self addForm: #( save cancel ).! !

!MAComponent methodsFor: 'forms' stamp: 'lr 4/4/2005 08:36'!
addForm: aCollection
	self addDecoration: (MAFormDecoration buttons: aCollection).! !

!MAComponent methodsFor: 'forms' stamp: 'lr 3/14/2005 11:58'!
addValidatedForm
	self addValidatedForm: #( save cancel ).! !

!MAComponent methodsFor: 'forms' stamp: 'lr 4/4/2005 08:35'!
addValidatedForm: aCollection
	self addDecoration: (MAFormDecoration buttons: aCollection).
	self addDecoration: (MAValidationDecoration new).! !

!MAComponent methodsFor: 'private' stamp: 'lr 3/28/2005 20:11'!
buildComponent: anObject
	^self buildComponent: anObject description: anObject description.! !

!MAComponent methodsFor: 'private' stamp: 'lr 4/6/2005 23:01'!
buildComponent: anObject description: aDescription
	^(aDescription asComponentOn: anObject wrapper: self wrapper class renderer: self renderer)
		setParent: self;
		yourself.! !

!MAComponent methodsFor: 'actions-conveniance' stamp: 'lr 3/30/2005 16:09'!
cancel
	self reset; answer: nil.! !

!MAComponent methodsFor: 'private' stamp: 'lr 4/4/2005 20:30'!
chooser: aComponent
	self chooser: aComponent titled: 'Select ' , self description label.! !

!MAComponent methodsFor: 'private' stamp: 'lr 4/4/2005 20:25'!
chooser: aComponent titled: aString
	| result |
	result := self container call: (aComponent
		addMessage: aString;
		yourself).
	result isNil
		ifFalse: [ self value: result ].! !

!MAComponent methodsFor: 'actions-conveniance' stamp: 'lr 3/30/2005 16:09'!
close
	self reset; answer: nil.! !

!MAComponent methodsFor: 'actions' stamp: 'al 4/13/2005 14:43'!
commit
	self description isReadonly ifFalse: [
		self wrapper commit ].! !

!MAComponent methodsFor: 'accessing-dynamic' stamp: 'lr 4/4/2005 18:20'!
container
	^self hasParentComponent
		ifTrue: [ self parent ]
		ifFalse: [ self ].! !

!MAComponent methodsFor: 'accessing-dynamic' stamp: 'lr 4/9/2005 02:51'!
description
	^self wrapper owner.! !

!MAComponent methodsFor: 'testing' stamp: 'lr 4/9/2005 12:33'!
hasMultipartData
	^false! !

!MAComponent methodsFor: 'testing' stamp: 'lr 4/4/2005 18:17'!
hasParentComponent
	^self parent notNil.! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 4/4/2005 18:19'!
parent
	^parent! !

!MAComponent methodsFor: 'accessing-conveniance' stamp: 'lr 3/30/2005 17:06'!
readonly
	^self renderer readonly.! !

!MAComponent methodsFor: 'accessing-conveniance' stamp: 'lr 3/30/2005 17:05'!
readonly: aBoolean
	self renderer readonly: aBoolean.! !

!MAComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 22:13'!
renderContentOn: html
	self renderer
		component: self;
		html: html;
		visit: self description.! !

!MAComponent methodsFor: 'rendering-parts' stamp: 'lr 3/21/2005 20:57'!
renderEditorOn: html 
	self renderViewerOn: html.! !

!MAComponent methodsFor: 'rendering-parts' stamp: 'lr 3/14/2005 17:08'!
renderLabelOn: html
	self description label isEmptyOrNil ifFalse: [
		html render: self description label; text: ':' ].
	self renderRequiredOn: html.! !

!MAComponent methodsFor: 'rendering-parts' stamp: 'lr 3/22/2005 09:36'!
renderRequiredOn: html 
	(self description isRequired 
		and: [ self description isReadonly not ] 
		and: [ self renderer isReadonly not ])
			ifTrue: [ html spanClass: 'required' with: '*' ].! !

!MAComponent methodsFor: 'rendering-parts' stamp: 'lr 4/9/2005 12:34'!
renderViewerOn: html
	self subclassResponsibility.! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 3/3/2005 16:16'!
renderer
	^renderer! !

!MAComponent methodsFor: 'actions' stamp: 'lr 3/30/2005 16:16'!
reset
	self wrapper reset.! !

!MAComponent methodsFor: 'actions-conveniance' stamp: 'lr 3/30/2005 16:24'!
save
	self validate; commit; answer: self value.! !

!MAComponent methodsFor: 'initialization' stamp: 'lr 4/4/2005 17:37'!
setParent: aComponent
	parent := aComponent! !

!MAComponent methodsFor: 'initialization' stamp: 'lr 3/30/2005 14:56'!
setRenderer: aRenderer
	renderer := aRenderer! !

!MAComponent methodsFor: 'initialization' stamp: 'lr 3/30/2005 14:55'!
setWrapper: aWrapper
	wrapper := aWrapper! !

!MAComponent methodsFor: 'actions' stamp: 'lr 4/7/2005 23:23'!
validate
	self wrapper validate.! !

!MAComponent methodsFor: 'accessing-wrapper' stamp: 'lr 3/30/2005 15:39'!
value
	^self wrapper value.! !

!MAComponent methodsFor: 'accessing-wrapper' stamp: 'lr 3/30/2005 15:39'!
value: anObject
	self wrapper value: anObject.! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 3/30/2005 14:48'!
wrapper
	^wrapper! !

MAComponent subclass: #MAContainerComponent
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAContainerComponent methodsFor: 'private' stamp: 'lr 4/4/2005 18:07'!
buildChildren
	^Array streamContents: [ :stream |
		self description do: [ :each |
			each isVisible ifTrue: [
				stream nextPut: (self
					buildComponent: self wrapper value
					description: each) ] ] ].! !

!MAContainerComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 22:31'!
children
	children isNil
		ifTrue: [ self children: self buildChildren ].
	^children.! !

!MAContainerComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 22:06'!
children: aCollection
	children := aCollection! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 4/5/2005 13:14'!
commit
	self children do: [ :each | each commit ].
	! !

!MAContainerComponent methodsFor: 'testing' stamp: 'lr 4/4/2005 08:40'!
hasMultipartData
	^self children anySatisfy: [ :each | each hasMultipartData ].! !

!MAContainerComponent methodsFor: 'rendering' stamp: 'lr 3/30/2005 15:58'!
renderViewerOn: html
	self children do: [ :each | html render: each ].! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 4/5/2005 13:14'!
reset
	self children do: [ :each | each reset ].! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 4/8/2005 11:34'!
validate
	self children do: [ :each | each validate ].! !

MAComponent subclass: #MAElementComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

MAElementComponent subclass: #MACheckboxComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MACheckboxComponent methodsFor: 'rendering' stamp: 'lr 3/28/2005 11:10'!
renderEditorOn: html
	html label: [
		html attributes: self description attributes.
		html checkboxOn: #value of: self. 
		html render: self description label ].! !

!MACheckboxComponent methodsFor: 'rendering' stamp: 'lr 3/28/2005 11:09'!
renderViewerOn: html
	html render: (self description toString: self value).! !

MAElementComponent subclass: #MADurationInputComponent
	instanceVariableNames: 'fields days hours minutes seconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MADurationInputComponent methodsFor: 'private' stamp: 'lr 4/7/2005 11:09'!
buildDuration
	^[ Duration days: self days hours: self hours minutes: self minutes seconds: self seconds ]
		on: Error
		do: [ :err | self wrapper errorValidation ].! !

!MADurationInputComponent methodsFor: 'private' stamp: 'lr 4/7/2005 11:11'!
buildField: aSelector label: aString size: anInteger
	^(MANumberDescription selector: aSelector label: self description label , '(' , aString , ')')
		attributes: (Array with: 'size' -> anInteger with: 'maxlength' -> anInteger);
		propertyAt: #shortlabel put: aString;
		asComponentOn: self.! !

!MADurationInputComponent methodsFor: 'private' stamp: 'lr 4/7/2005 10:56'!
buildFields
	^Array
		with: (self buildField: #days label: 'days' size: 3)
		with: (self buildField: #hours label: 'hours' size: 2)
		with: (self buildField: #minutes label: 'minutes' size: 2)
		with: (self buildField: #seconds label: 'seconds' size: 2).! !

!MADurationInputComponent methodsFor: 'actions' stamp: 'lr 4/7/2005 11:23'!
commit
	| empty |
	self fields do: [ :each | each commit ].
	empty := self fields allSatisfy: [ :each | 
		each value isNil
			or: [ each value isString ] ].
	self value: (empty
		ifTrue: [ nil ] 
		ifFalse: [ self buildDuration ]).
	super commit.! !

!MADurationInputComponent methodsFor: 'private-accessing' stamp: 'lr 4/7/2005 11:05'!
days
	days isNil ifTrue: [
		days := self value isNil
			ifTrue: [ String new ]
			ifFalse: [ self value days ] ].
	^days.! !

!MADurationInputComponent methodsFor: 'private-accessing' stamp: 'lr 4/7/2005 11:22'!
days: anInteger
	days := anInteger isNil
		ifFalse: [ anInteger ]
		ifTrue: [ 0 ].! !

!MADurationInputComponent methodsFor: 'accessing' stamp: 'lr 4/7/2005 10:56'!
fields
	fields isNil
		ifTrue: [ fields := self buildFields ].
	^fields.! !

!MADurationInputComponent methodsFor: 'private-accessing' stamp: 'lr 4/7/2005 11:06'!
hours
	hours isNil ifTrue: [
		hours := self value isNil
			ifTrue: [ String new ]
			ifFalse: [ self value hours ] ].
	^hours.! !

!MADurationInputComponent methodsFor: 'private-accessing' stamp: 'lr 4/7/2005 11:22'!
hours: anInteger
	hours := anInteger isNil
		ifFalse: [ anInteger ]
		ifTrue: [ 0 ].! !

!MADurationInputComponent methodsFor: 'private-accessing' stamp: 'lr 4/7/2005 11:06'!
minutes
	minutes isNil ifTrue: [
		minutes := self value isNil
			ifTrue: [ String new ]
			ifFalse: [ self value minutes ] ].
	^minutes.! !

!MADurationInputComponent methodsFor: 'private-accessing' stamp: 'lr 4/7/2005 11:22'!
minutes: anInteger
	minutes := anInteger isNil
		ifFalse: [ anInteger ]
		ifTrue: [ 0 ].! !

!MADurationInputComponent methodsFor: 'rendering' stamp: 'lr 4/7/2005 11:11'!
renderEditorOn: html
	self fields 
		do: [ :each | 
			each renderEditorOn: html.
			html render: (each description propertyAt: #shortlabel) ]
		separatedBy: [ html space: 2 ].! !

!MADurationInputComponent methodsFor: 'actions' stamp: 'lr 4/7/2005 11:08'!
reset
	super reset.
	fields := days := hours := minutes := seconds := nil.! !

!MADurationInputComponent methodsFor: 'private-accessing' stamp: 'lr 4/7/2005 11:06'!
seconds
	seconds isNil ifTrue: [
		seconds := self value isNil
			ifTrue: [ String new ]
			ifFalse: [ self value seconds ] ].
	^seconds.! !

!MADurationInputComponent methodsFor: 'private-accessing' stamp: 'lr 4/7/2005 11:22'!
seconds: anInteger
	seconds := anInteger isNil
		ifFalse: [ anInteger ]
		ifTrue: [ 0 ].! !

!MAElementComponent methodsFor: 'rendering' stamp: 'lr 3/28/2005 22:08'!
renderViewerOn: html
	html render: self string.! !

!MAElementComponent methodsFor: 'private' stamp: 'lr 4/6/2005 23:48'!
showHalo
	^false! !

!MAElementComponent methodsFor: 'accessing' stamp: 'lr 3/28/2005 22:12'!
string
	^self description toString: self value.! !

!MAElementComponent methodsFor: 'accessing' stamp: 'lr 3/28/2005 22:13'!
string: aString
	self value: (self description parseString: aString).! !

MAElementComponent subclass: #MAFileUploadComponent
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAFileUploadComponent methodsFor: 'accessing' stamp: 'lr 4/4/2005 21:46'!
file
	^file! !

!MAFileUploadComponent methodsFor: 'accessing' stamp: 'lr 4/4/2005 21:46'!
file: aFile
	file := aFile! !

!MAFileUploadComponent methodsFor: 'testing' stamp: 'lr 4/4/2005 08:41'!
hasMultipartData
	^true! !

!MAFileUploadComponent methodsFor: 'actions' stamp: 'lr 4/8/2005 16:27'!
remove
	self file: nil; value: nil.! !

!MAFileUploadComponent methodsFor: 'rendering' stamp: 'lr 4/8/2005 16:28'!
renderEditorOn: html
	self value isEmptyOrNil 
		ifTrue: [ self renderUploadOn: html ]
		ifFalse: [ self renderRemoveOn: html ].! !

!MAFileUploadComponent methodsFor: 'rendering' stamp: 'lr 4/8/2005 16:27'!
renderRemoveOn: html
	self renderViewerOn: html.
	html space; submitButtonOn: #remove of: self.! !

!MAFileUploadComponent methodsFor: 'rendering' stamp: 'lr 4/4/2005 21:44'!
renderUploadOn: html
	html attributes: self description attributes.
	html fileUploadWithCallback: [ :value | self upload: value ].
	html submitButtonOn: #upload of: self.! !

!MAFileUploadComponent methodsFor: 'rendering' stamp: 'lr 4/4/2005 21:42'!
renderViewerOn: html 
	html render: (self value ifNotNilDo: [ :value | 
		value size asFileSize ]).! !

!MAFileUploadComponent methodsFor: 'actions' stamp: 'lr 4/6/2005 23:46'!
upload
	self file notNil ifTrue: [
		self parent children do: [ :each |
			(each description propertyAt: self description key ifAbsent: nil) in: [ :kind |
				kind = #filename ifTrue: [ each wrapper value: self file fileName ].
				kind = #mimetype ifTrue: [ each wrapper value: self file contentType ] ] ] ].	! !

!MAFileUploadComponent methodsFor: 'actions' stamp: 'lr 4/4/2005 21:46'!
upload: aFile
	self file: aFile.
	self value: (aFile isNil
		ifFalse: [ aFile contents asByteArray ]
		ifTrue: [ nil ]).! !

MAElementComponent subclass: #MAOptionsComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAOptionsComponent methodsFor: 'private' stamp: 'lr 4/12/2005 14:26'!
labelForObject: anObject
	^anObject isNil
		ifTrue: [ self description nilLabel ]
		ifFalse: [ anObject asLabel ].! !

MAOptionsComponent subclass: #MARadioGroupComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MARadioGroupComponent methodsFor: 'rendering' stamp: 'lr 4/12/2005 14:28'!
renderEditorOn: html
	html radioGroup in: [ :group |
		self description allOptions
			do: [ :each |
				html label: [
					html attributes: self description attributes.
					html 
						radioButtonInGroup: group
						selected: self value = each
						callback: (MessageSend
							receiver: self
							selector: #value:).
					html render: (self labelForObject: each) ] ]
			separatedBy: [ html break ] ].! !

MAOptionsComponent subclass: #MASelectListComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MASelectListComponent methodsFor: 'rendering' stamp: 'lr 4/12/2005 14:11'!
renderEditorOn: html
	html attributes: self description attributes.
	html 
		selectFromList: self description allOptions
		selected: self value
		callback: (MessageSend
			receiver: self
			selector: #value:)
		labels: (MessageSend
			receiver: self
			selector: #labelForObject:).! !

MAElementComponent subclass: #MATableComponent
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATableComponent methodsFor: 'private' stamp: 'lr 3/29/2005 22:50'!
buildCells
	| row column |
	^self value collectWithIndex: [ :each :index |
		row := self description rowOfIndex: index.
		column := self description columnOfIndex: index.
		self description cellDescription copy
			accessor: MANullAccessor new;
			propertyAt: #tableIndex put: index;
			label: (String streamContents: [ :stream |
				stream nextPutAll: (self description label); nextPutAll: ' ('.
				stream nextPutAll: (self description columnLabels at: column); nextPutAll: ' / '.
				stream nextPutAll: (self description rowLabels at: row); nextPutAll: ')' ]);
			comment: (String streamContents: [ :stream |
				stream nextPutAll: (self description columnLabels at: column); nextPutAll: ' / '.
				stream nextPutAll: (self description rowLabels at: row) ]);
			asComponentOn: self ].	! !

!MATableComponent methodsFor: 'accessing-dynamic' stamp: 'lr 3/29/2005 21:42'!
cellAt: aRowIndex at: aColIndex
	^self cells at: (self description indexAt: aRowIndex at: aColIndex).! !

!MATableComponent methodsFor: 'accessing' stamp: 'lr 3/29/2005 21:15'!
cells
	cells isNil
		ifTrue: [ cells := self buildCells ].
	^cells.! !

!MATableComponent methodsFor: 'actions' stamp: 'lr 3/15/2005 22:51'!
commit
	self cells do: [ :each | each commit ].
	super commit.! !

!MATableComponent methodsFor: 'private' stamp: 'lr 3/29/2005 22:02'!
readUsing: aDescription
	^self value at: (aDescription propertyAt: #tableIndex).! !

!MATableComponent methodsFor: 'rendering' stamp: 'lr 3/15/2005 22:59'!
renderEditorOn: html
	self 
		renderTableCells: [ :cell | cell renderEditorOn: html ]
		on: html.! !

!MATableComponent methodsFor: 'rendering' stamp: 'lr 3/29/2005 21:48'!
renderTableCells: aBlock on: html
	html table: [
		html tableRow: [
			html tableHeading: nil.
			self description columnLabels do: [ :each |
				html tableHeading: each ] ].
		self description rowLabels withIndexDo: [ :row :rindex |
			html tableRow: [
				html tableHeading: row.
				self description columnLabels withIndexDo: [ :col :cindex |
					(self cellAt: rindex at: cindex) in: [ :component |
						html attributeAt: 'title' put: component description comment.
						html tableData: [ aBlock value: component ] ] ] ] ] ].! !

!MATableComponent methodsFor: 'rendering' stamp: 'lr 3/15/2005 22:59'!
renderViewerOn: html
	self 
		renderTableCells: [ :cell | cell renderViewerOn: html ]
		on: html.! !

!MATableComponent methodsFor: 'actions' stamp: 'lr 4/7/2005 17:01'!
reset
	super reset.
	self cells do: [ :each | each reset ].! !

!MATableComponent methodsFor: 'actions' stamp: 'lr 4/7/2005 17:08'!
validate
	self cells do: [ :each | each validate ].
	super validate.! !

!MATableComponent methodsFor: 'accessing' stamp: 'lr 3/29/2005 21:53'!
value
	(self description includes: super value)
		ifFalse: [ self value: (Array new: self description cellCount) ].
	^super value.! !

!MATableComponent methodsFor: 'private' stamp: 'lr 3/29/2005 22:03'!
write: anObject using: aDescription
	^self value at: (aDescription propertyAt: #tableIndex) put: anObject.! !

MAElementComponent subclass: #MATextAreaComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATextAreaComponent methodsFor: 'rendering' stamp: 'lr 3/29/2005 10:34'!
renderEditorOn: html 
	html attributes: self description attributes.
	html textAreaOn: #value of: self.! !

!MATextAreaComponent methodsFor: 'rendering' stamp: 'lr 3/31/2005 11:34'!
renderViewerOn: html
	self value isNil ifFalse: [
		self value lines
			do: [ :each | html render: each ]
			separatedBy: [ html break ] ].! !

MAElementComponent subclass: #MATextInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

MATextInputComponent subclass: #MADateInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MADateInputComponent methodsFor: 'actions' stamp: 'lr 4/4/2005 20:50'!
choose
	| calendar |
	calendar := WAMiniCalendar new.
	calendar
		date: ((self description includes: self value)
			ifFalse: [ Date current ]
			ifTrue: [ self value ]);
		selectBlock: [ :date | calendar answer: date ];
		canSelectBlock: [ :date | true ].
	self chooser: calendar.! !

!MADateInputComponent methodsFor: 'rendering' stamp: 'lr 4/4/2005 20:38'!
renderEditorOn: html
	super renderEditorOn: html.
	html submitButtonOn: #choose of: self.! !

!MATextInputComponent methodsFor: 'rendering' stamp: 'lr 3/28/2005 22:38'!
renderEditorOn: html
	html attributes: self description attributes.
	html textInputOn: #string of: self.! !

MATextInputComponent subclass: #MATimeInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATimeInputComponent methodsFor: 'actions' stamp: 'lr 4/6/2005 23:34'!
current
	self value: Time current.! !

!MATimeInputComponent methodsFor: 'rendering' stamp: 'lr 4/6/2005 23:34'!
renderEditorOn: html
	super renderEditorOn: html.
	html submitButtonOn: #current of: self.! !

MATextInputComponent subclass: #MATimeStampInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATimeStampInputComponent methodsFor: 'actions' stamp: 'lr 4/6/2005 23:35'!
current
	self value: TimeStamp current.! !

!MATimeStampInputComponent methodsFor: 'rendering' stamp: 'lr 4/6/2005 23:35'!
renderEditorOn: html
	super renderEditorOn: html.
	html submitButtonOn: #current of: self.! !

MAElementComponent subclass: #MATextPasswordComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATextPasswordComponent methodsFor: 'rendering' stamp: 'lr 4/6/2005 23:29'!
renderEditorOn: html 
	html attributes: self description attributes.
	html 
		passwordInputWithValue: self string
		callback: (MessageSend 
			receiver: self 
			selector: #string:).! !

!MATextPasswordComponent methodsFor: 'actions' stamp: 'lr 4/6/2005 23:28'!
string
	^self description obfuscated: super string.! !

!MATextPasswordComponent methodsFor: 'actions' stamp: 'lr 4/6/2005 23:29'!
string: aString
	(self description isObfuscated: aString)
		ifFalse: [ super string: aString ].! !

MAComponent subclass: #MAReportComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAReportComponent methodsFor: 'rendering' stamp: 'lr 3/24/2005 15:16'!
renderContentOn: html
	self description isEmptyOrNil
		ifFalse: [ self renderTableCaptionOn: html ].
	self description isEmptyOrNil
		ifFalse: [ self renderTableSummaryOn: html ].
	html tag: 'thead' do: [
		self description showHeader
			ifTrue: [ self renderTableHeadOn: html ] ].
	html tag: 'tbody' do: [
		self description showBody 
			ifTrue: [ self renderTableBodyOn: html ] ].
	html tag: 'tfoot' do: [
		self description showFooter
			ifTrue: [ self renderTableFootOn: html ].
		self description showBatch
			ifTrue: [ self renderTableBatchOn: html ] ].! !

WAComponent subclass: #MAExampleEditor
	instanceVariableNames: 'description report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Examples'!

MAExampleEditor subclass: #MADescriptionEditor
	instanceVariableNames: 'example'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Examples'!

!MADescriptionEditor class methodsFor: 'examples' stamp: 'lr 4/4/2005 10:26'!
example
	^self description: MADescribedScaffolder description.! !

!MADescriptionEditor methodsFor: 'actions-items' stamp: 'lr 4/9/2005 12:38'!
addDescription: aDescription
	| element |
	element := self call: (self 
		buildEditorFor: aDescription 
		titled: 'Add ' , aDescription description label).
	element isNil ifTrue: [ ^self ].
	self description add: element.
	self report refresh.! !

!MADescriptionEditor methodsFor: 'private' stamp: 'lr 4/9/2005 02:51'!
buildEditorFor: aDescription titled: aString
	^aDescription asComponent
		addValidatedForm;
		addMessage: aString;
		yourself.! !

!MADescriptionEditor methodsFor: 'private' stamp: 'lr 3/24/2005 14:58'!
buildReport
	^(MAReport rows: self description description: MAElementDescription description)
		addColumn: (MAColumn new
			cascade: #( description label );
			title: 'Kind';
			yourself);
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #editDescription: text: 'edit';
			addCommandOn: self selector: #moveUp: text: 'up';
			addCommandOn: self selector: #moveDown: text: 'down';
			addCommandOn: self selector: #removeDescription: text: 'remove';
			yourself);
		yourself.! !

!MADescriptionEditor methodsFor: 'accessing-configuration' stamp: 'lr 3/21/2005 18:55'!
defaultDescriptionClasses
	^OrderedCollection new
		add: MAStringDescription;
		add: MATextDescription;
		add: MASymbolDescription;
		add: MAPasswordDescription;
		add: nil;
		add: MABooleanDescription;
		add: MAOptionsDescription;
		add: nil;
		add: MANumberDescription;
		add: MADurationDescription;
		add: MADateDescription;
		add: MATimeDescription;
		add: MATimeStampDescription;
		add: nil;
		add: MATableDescription;
		add: MABinaryDescription;
		yourself.! !

!MADescriptionEditor methodsFor: 'accessing-configuration' stamp: 'lr 4/4/2005 10:26'!
defaultExampleInstance
	^MADescribedScaffolder description: self description.! !

!MADescriptionEditor methodsFor: 'accessing-configuration' stamp: 'lr 3/21/2005 19:39'!
defaultReportInstance
	^(MAReport rows: self description description: MAElementDescription description)
		addColumn: (MAColumn new
			cascade: #( description label );
			title: 'Kind';
			yourself);
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #editDescription: text: 'edit';
			addCommandOn: self selector: #moveUp: text: 'up';
			addCommandOn: self selector: #moveDown: text: 'down';
			addCommandOn: self selector: #removeDescription: text: 'remove';
			yourself);
		yourself.! !

!MADescriptionEditor methodsFor: 'actions-items' stamp: 'lr 3/21/2005 19:41'!
editDescription: aDescription
	self call: (self 
		buildEditorFor: aDescription 
		titled: 'Edit ' , aDescription description label).
	self report refresh.! !

!MADescriptionEditor methodsFor: 'accessing' stamp: 'lr 3/21/2005 19:38'!
example
	example isNil
		ifTrue: [ example := self defaultExampleInstance ].
	^example.! !

!MADescriptionEditor methodsFor: 'actions' stamp: 'lr 3/21/2005 19:41'!
preview
	self call: (self example asComponent
		addValidatedForm;
		yourself).! !

!MADescriptionEditor methodsFor: 'actions-items' stamp: 'lr 3/21/2005 19:41'!
removeDescription: aDescription
	self description remove: aDescription.
	self report refresh.! !

!MADescriptionEditor methodsFor: 'rendering' stamp: 'lr 3/28/2005 22:45'!
renderCommandsOn: html
	| selected |
	selected := ValueHolder new.
	html
		selectFromList: self defaultDescriptionClasses 
		selected: self defaultDescriptionClasses first
		callback: [ :class | selected contents: class ]
		labels: [ :class | 
			class isNil
				ifTrue: [ '--' ]
				ifFalse: [ class description label ] ].
	html
		submitButtonWithAction: [
			selected contents ifNotNilDo: [ :class | 
				self addDescription: class new ] ]
		text: 'Add'.
	super renderCommandsOn: html.! !

!MAExampleEditor class methodsFor: 'instance creation' stamp: 'lr 3/24/2005 14:43'!
description: aDescription
	^self new
		setDescription: aDescription;
		yourself.! !

!MAExampleEditor methodsFor: 'private' stamp: 'lr 3/24/2005 14:41'!
buildReport
	self subclassResponsibility.! !

!MAExampleEditor methodsFor: 'actions' stamp: 'lr 3/22/2005 23:44'!
cancel
	self answer: nil.! !

!MAExampleEditor methodsFor: 'accessing' stamp: 'lr 3/24/2005 14:41'!
children
	^Array with: self report.! !

!MAExampleEditor methodsFor: 'accessing' stamp: 'lr 3/24/2005 14:38'!
description
	^description! !

!MAExampleEditor methodsFor: 'actions-items' stamp: 'lr 3/24/2005 14:51'!
moveDown: aDescription
	self description moveDown: aDescription.
	self report refresh.! !

!MAExampleEditor methodsFor: 'actions-items' stamp: 'lr 3/24/2005 14:51'!
moveUp: aDescription
	self description moveUp: aDescription.
	self report refresh.! !

!MAExampleEditor methodsFor: 'actions' stamp: 'lr 3/22/2005 23:46'!
preview
	self subclassResponsibility.! !

!MAExampleEditor methodsFor: 'rendering' stamp: 'lr 3/24/2005 14:54'!
renderActionsOn: html
	html submitButtonOn: #save of: self.
	html submitButtonOn: #cancel of: self.! !

!MAExampleEditor methodsFor: 'rendering' stamp: 'lr 3/24/2005 14:54'!
renderButtonsOn: html
	html form: [
		self renderCommandsOn: html.
		self renderActionsOn: html ].! !

!MAExampleEditor methodsFor: 'rendering' stamp: 'lr 3/22/2005 23:48'!
renderChildrenOn: html
	html render: self children.! !

!MAExampleEditor methodsFor: 'rendering' stamp: 'lr 3/24/2005 14:55'!
renderCommandsOn: html
	html submitButtonOn: #preview of: self.! !

!MAExampleEditor methodsFor: 'rendering' stamp: 'lr 3/22/2005 23:48'!
renderContentOn: html
	self renderChildrenOn: html.
	self renderButtonsOn: html.! !

!MAExampleEditor methodsFor: 'accessing' stamp: 'lr 3/24/2005 14:40'!
report
	report isNil
		ifTrue: [ report := self buildReport ].
	^report.! !

!MAExampleEditor methodsFor: 'actions' stamp: 'lr 3/24/2005 14:39'!
save
	 self answer: self description.! !

!MAExampleEditor methodsFor: 'initialization' stamp: 'lr 3/24/2005 14:50'!
setDescription: aDescription
	description := aDescription 
		collect: [ :each | each copy ].! !

MAExampleEditor subclass: #MAReportEditor
	instanceVariableNames: 'columns visible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Examples'!

!MAReportEditor class methodsFor: 'examples' stamp: 'lr 4/4/2005 10:26'!
example
	^self description: MADescribedScaffolder example description.! !

!MAReportEditor methodsFor: 'actions' stamp: 'lr 3/23/2005 00:01'!
addColumn: aColumn
	self report addColumn: aColumn.
	self refresh.! !

!MAReportEditor methodsFor: 'private' stamp: 'lr 3/23/2005 00:30'!
buildColumns
	^(MAReport rows: self report columns)
		addColumn: self visible;
		addColumnDescription: MAColumn descriptionTitle;
		addColumnDescription: MAColumn descriptionComment;
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #moveUp: text: 'up';
			addCommandOn: self selector: #moveDown: text: 'down';
			addCommandOn: self selector: #remove: text: 'remove';
			yourself);
		yourself.
			! !

!MAReportEditor methodsFor: 'private' stamp: 'lr 3/23/2005 00:39'!
buildVisible
	^MACheckboxColumn new
		title: 'V';
		comment: 'Visibility';
		selection: (self report columns 
			select: [ :each | each isVisible ])
			asSet;
		yourself.! !

!MAReportEditor methodsFor: 'accessing' stamp: 'lr 3/23/2005 00:06'!
children
	^Array with: self columns.! !

!MAReportEditor methodsFor: 'accessing' stamp: 'lr 3/22/2005 23:21'!
columns
	columns isNil
		ifTrue: [ columns := self buildColumns ].
	^columns.! !

!MAReportEditor methodsFor: 'actions' stamp: 'lr 3/23/2005 00:09'!
preview	
	self report
		decorateWith: (WAWindowDecoration new
			title: self report tableCaption;
			yourself)
		during: [ self call: self report ].! !

!MAReportEditor methodsFor: 'actions' stamp: 'lr 3/23/2005 00:00'!
refresh
	self columns rows: self report columns.! !

!MAReportEditor methodsFor: 'actions' stamp: 'lr 3/23/2005 00:01'!
remove: aColumn
	self report remove: aColumn.
	self refresh.! !

!MAReportEditor methodsFor: 'rendering' stamp: 'lr 3/23/2005 00:07'!
renderAddOn: html
	| selected |
	selected := ValueHolder new.
	"html
		selectFromList: self columns selected: nil
		callback: [ :value | selected contents: value ]
		labels: [ :value | value title ]."
	html
		submitButtonWithAction: [
			selected contents ifNotNilDo: [ :value | 
				self addColumn: value copy ] ]
		text: 'add'.! !

!MAReportEditor methodsFor: 'accessing' stamp: 'lr 3/22/2005 23:21'!
report
	^report! !

!MAReportEditor methodsFor: 'actions' stamp: 'lr 3/22/2005 23:45'!
save
	 self answer: self report.! !

!MAReportEditor methodsFor: 'initialization' stamp: 'lr 3/23/2005 00:02'!
setReport: aReport
	report := aReport copy.! !

!MAReportEditor methodsFor: 'accessing' stamp: 'lr 3/23/2005 00:32'!
visible
	visible isNil
		ifTrue: [ visible := self buildVisible ].
	^visible.! !

WAComponent subclass: #MAReport
	instanceVariableNames: 'rows cache columns properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 3/28/2005 12:24'!
description2000
	^MABooleanDescription selector: #showHeader label: 'Show Header' priority: 2000.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 3/28/2005 12:24'!
description2100
	^MABooleanDescription selector: #showBody label: 'Show Body' priority: 2100.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 3/28/2005 12:24'!
description2200
	^MAStringDescription selector: #tableEmpty label: 'Empty' priority: 2200.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 3/28/2005 12:24'!
description2300
	^MABooleanDescription selector: #showFooter label: 'Show Footer' priority: 2300.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 3/28/2005 12:24'!
description2400
	^MABooleanDescription selector: #showCaption label: 'Show Caption' priority: 2300.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 3/28/2005 12:24'!
description2500
	^MAStringDescription selector: #tableCaption label: 'Caption' priority: 2500.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 3/28/2005 12:24'!
description2600
	^MABooleanDescription selector: #showSummary label: 'Show Summary' priority: 2600.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 3/28/2005 12:24'!
description2700
	^MAStringDescription selector: #tableSummary label: 'Summary' priority: 2700.! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 3/28/2005 12:24'!
description4000
	^MABooleanDescription selector: #showBatch label: 'Show Batch' priority: 4000.! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 3/28/2005 12:24'!
description4100
	^MANumberDescription selector: #batchSize label: 'Size' priority: 4100.! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 3/28/2005 12:24'!
description4200
	^MABooleanDescription selector: #showBatchFirstLast label: 'Show First/Last' priority: 4200.! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 3/28/2005 12:24'!
description4300
	^MABooleanDescription selector: #showBatchPreviousNext label: 'Show Previous/Next' priority: 4300.! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 3/28/2005 12:24'!
description4400
	^MABooleanDescription selector: #showBatchPages label: 'Show Pages' priority: 4400.! !

!MAReport class methodsFor: 'examples' stamp: 'lr 3/23/2005 00:24'!
example
	^(MAReport rows: (0 to: 255))
		addColumn: (MAColumn new
			selector: #yourself;
			comment: 'the decimal number';
			title: 'Dec');
		addColumn: (MAColumn new
			selector: #yourself;
			comment: 'the binary number';
			title: 'Bin';
			format: [ :value | (value printStringBase: 2) allButFirst: 2 ];
			yourself);
		addColumn: (MAColumn new
			selector: #yourself;
			comment: 'the octal number';
			title: 'Oct';
			format: [ :value | (value printStringBase: 8) allButFirst: 2 ];
			yourself);
		addColumn: (MAColumn new
			selector: #yourself;
			comment: 'the hexadecimal number';
			title: 'Hex';
			format: [ :value | (value printStringBase: 16) allButFirst: 3 ];
			yourself);
		addColumn: (MAColumn new
			selector: #sin;
			comment: 'the sinus';
			title: 'Sinus');
		addColumn: (MAColumn new
			selector: #cos;
			comment: 'the cosinus';
			title: 'Cosinus');
		addColumn: (MAColumn new
			selector: #ln;
			comment: 'the natural logarithm';
			title: 'Logarithm');
		addColumn: (MAColumn new
			selector: #exp;
			comment: 'the exponential';
			title: 'Exponential');
		yourself.! !

!MAReport class methodsFor: 'instance creation' stamp: 'lr 3/21/2005 16:45'!
rows: aCollection
	^self new
		rows: aCollection;
		yourself.! !

!MAReport class methodsFor: 'instance creation' stamp: 'lr 3/24/2005 00:06'!
rows: aCollection description: aDescription
	| report |
	report := self rows: aCollection.
	aDescription asContainer do: [ :each |
		report addColumnDescription: each ].
	^report.! !

!MAReport methodsFor: 'README' stamp: 'lr 4/9/2005 15:39'!
NOW
	" do not use ... this is unfinished and not working "! !

!MAReport methodsFor: 'columns' stamp: 'lr 3/21/2005 16:56'!
addColumn: aColumn
	columns := columns copyWith: aColumn.
	^aColumn setReport: self; yourself.! !

!MAReport methodsFor: 'columns' stamp: 'lr 3/21/2005 19:08'!
addColumnCascade: anArray
	^(self addColumn: MAColumn new)
		cascade: anArray;
		yourself.! !

!MAReport methodsFor: 'columns' stamp: 'lr 3/21/2005 17:40'!
addColumnDescription: aDescription
	^self addColumn: (MADescribedColumn new
		setDescription: aDescription;
		yourself).! !

!MAReport methodsFor: 'columns' stamp: 'lr 3/21/2005 19:09'!
addColumnSelector: aSelector
	^(self addColumn: MAColumn new)
		selector: aSelector;
		yourself.! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 16:25'!
backtrackedAt: aSymbol
	^(self propertyAt: aSymbol)
		contents.! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 16:27'!
backtrackedAt: aSymbol ifAbsent: aBlock
	^(self propertyAt: aSymbol ifAbsent: [ ^aBlock value ])
		contents.! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 16:29'!
backtrackedAt: aSymbol ifAbsentPut: aBlock
	^self 
		backtrackedAt: aSymbol 
		ifAbsent: [ self backtrackedAt: aSymbol put: aBlock value ].! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 16:26'!
backtrackedAt: aSymbol put: anObject
	(self propertyAt: aSymbol ifAbsentPut: [ WAStateHolder new ])
		contents: anObject.
	^anObject.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 3/21/2005 16:35'!
batchEndIndex
	^self batchPage * self batchSize min: self cache size.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 3/21/2005 16:35'!
batchMaxPages
	^(self cache size / self batchSize) 
		ceiling.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:42'!
batchPage
	^self backtrackedAt: #batchPage ifAbsentPut: [ self defaultBatchPage ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:37'!
batchPage: anInteger
	self backtrackedAt: #batchPage put: anInteger.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 3/21/2005 16:35'!
batchPageRange
	^self batchPageRangeStart to: self batchPageRangeEnd.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 3/21/2005 16:35'!
batchPageRangeEnd
	^self batchMaxPages min: self batchPage + 9.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 3/21/2005 16:35'!
batchPageRangeStart
	^self defaultBatchPage max: self batchPage - 9.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:42'!
batchSize
	^self propertyAt: #batchSize ifAbsentPut: [ self defaultBatchSize ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:37'!
batchSize: anInteger
	self propertyAt: #batchSize put: anInteger.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 3/21/2005 16:36'!
batchStartIndex
	^(self batchPage - 1) * self batchSize + 1.! !

!MAReport methodsFor: 'accessing' stamp: 'lr 3/21/2005 16:21'!
cache
	"Return the cached rows of the receiver, these rows are filtered and sorted."

	cache isNil ifTrue: [ 
		self cache: (self 
			sortRows: (self 
				filterRows: self 
					rows)) ].
	^cache.! !

!MAReport methodsFor: 'accessing' stamp: 'lr 3/21/2005 16:21'!
cache: aCollection
	cache := aCollection! !

!MAReport methodsFor: 'accessing-readonly' stamp: 'lr 3/21/2005 16:34'!
columns
	^columns! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:40'!
defaultBatchPage
	^1! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:40'!
defaultBatchSize
	^10! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:40'!
defaultRowFilter
	^nil! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:40'!
defaultRowPeriod
	^1! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultRowStyles
	^Array with: 'odd' with: 'even'.! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultShowBatch
	^true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 19:51'!
defaultShowBatchFirstLast
	^false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultShowBatchPages
	^true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultShowBatchPreviousNext
	^true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultShowBody
	^true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultShowCaption
	^false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultShowFooter
	^false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultShowHeader
	^true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultShowSummary
	^false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultSortArrowDown
	^ScriptingSystem formAtKey: #DownArrow.! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultSortArrowUp
	^ScriptingSystem formAtKey: #UpArrow.! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultSortColumn
	^nil! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultSortEnabled
	^true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultSortReversed
	^false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:42'!
defaultTableCaption
	^nil! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:42'!
defaultTableEmpty
	^'The report is empty.'! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:42'!
defaultTableSummary
	^nil! !

!MAReport methodsFor: 'private' stamp: 'lr 3/21/2005 16:30'!
filterRows: aCollection
	^self hasRowFilter
		ifFalse: [ aCollection ]
		ifTrue: [ aCollection select: self rowFilter ].! !

!MAReport methodsFor: 'testing' stamp: 'lr 3/21/2005 16:30'!
hasRowFilter
	^self rowFilter notNil.! !

!MAReport methodsFor: 'initialization' stamp: 'lr 3/21/2005 16:56'!
initialize
	super initialize.
	rows := columns := Array new.
	properties := Dictionary new.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 3/21/2005 16:36'!
isOnFirstPage
	^self batchPage = 1.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 3/21/2005 16:36'!
isOnLastPage
	^self batchPage = self batchMaxPages.! !

!MAReport methodsFor: 'testing' stamp: 'lr 3/21/2005 16:30'!
isSorted
	^self sortColumn notNil.! !

!MAReport methodsFor: 'columns' stamp: 'lr 3/22/2005 23:56'!
moveDown: aColumn
	| index |
	index := self columns indexOf: aColumn ifAbsent: [ ^self ].
	self columns swap: index with: (index = self size
		ifFalse:[ index + 1 ]
		ifTrue: [ 1 ]).! !

!MAReport methodsFor: 'columns' stamp: 'lr 3/22/2005 23:57'!
moveUp: aColumn
	| index |
	index := self columns indexOf: aColumn ifAbsent: [ ^self ].
	self columns swap: index with: (index = 1
		ifFalse:[ index - 1 ]
		ifTrue: [ self size ]).! !

!MAReport methodsFor: 'actions' stamp: 'lr 3/21/2005 16:34'!
nextPage
	self isOnLastPage 
		ifFalse: [ self batchPage: self batchPage + 1 ].! !

!MAReport methodsFor: 'actions' stamp: 'lr 3/21/2005 16:34'!
previousPage
	self isOnFirstPage 
		ifFalse: [ self batchPage: self batchPage - 1 ].! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 16:23'!
properties
	^properties! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 16:23'!
propertyAt: aSymbol
	^self properties at: aSymbol! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 16:23'!
propertyAt: aSymbol ifAbsent: aBlock
	^self properties at: aSymbol ifAbsent: aBlock.! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 16:23'!
propertyAt: aSymbol ifAbsentPut: aBlock
	^self properties at: aSymbol ifAbsentPut: aBlock.! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 16:22'!
propertyAt: aSymbol put: anObject
	^self properties at: aSymbol put: anObject.! !

!MAReport methodsFor: 'actions' stamp: 'lr 3/21/2005 16:34'!
refresh
	self cache: nil; batchPage: self defaultBatchPage.
	self columns do: [ :each | each refresh ].! !

!MAReport methodsFor: 'columns' stamp: 'lr 3/22/2005 23:58'!
remove: aColumn
	columns := columns copyWithout: aColumn.! !

!MAReport methodsFor: 'rendering-batch' stamp: 'lr 3/21/2005 16:32'!
renderBatchFirstOn: html
	self isOnFirstPage
		ifFalse: [ html anchorWithAction: [ self batchPage: self defaultBatchPage ] text: '|<' ]
		ifTrue: [ html text: '|<' ].
	html space.! !

!MAReport methodsFor: 'rendering-batch' stamp: 'lr 3/21/2005 16:32'!
renderBatchItemsOn: html
	self batchPageRangeStart > self defaultBatchPage
		ifTrue: [ html text: '...'; space ].
	self batchPageRange do: [ :index |
		self batchPage = index
			ifFalse: [ html anchorWithAction: [ self batchPage: index ] text: index ]
			ifTrue: [ html spanClass: 'current' with: index ].
		html space ].
	self batchPageRangeEnd < self batchMaxPages 
		ifTrue: [ html text: '...'; space ].! !

!MAReport methodsFor: 'rendering-batch' stamp: 'lr 3/21/2005 16:32'!
renderBatchLastOn: html
	self isOnLastPage
		ifFalse: [ html anchorWithAction: [ self batchPage: self batchMaxPages ] text: '>|' ]
		ifTrue: [ html text: '>|' ].! !

!MAReport methodsFor: 'rendering-batch' stamp: 'lr 3/21/2005 16:32'!
renderBatchNextOn: html
	self isOnLastPage
		ifFalse: [ html anchorWithAction: [ self nextPage ] text: '>>' ]
		ifTrue: [ html text: '>>' ].
	html space.! !

!MAReport methodsFor: 'rendering-batch' stamp: 'lr 3/21/2005 16:32'!
renderBatchPreviousOn: html
	self isOnFirstPage
		ifFalse: [ html anchorWithAction: [ self previousPage ] text: '<<' ]
		ifTrue: [ html text: '<<' ].
	html space.! !

!MAReport methodsFor: 'rendering' stamp: 'lr 3/21/2005 16:33'!
renderContentOn: html
	html cssClass: 'report'; table: [ self renderTableOn: html ].! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 3/21/2005 16:31'!
renderTableBatchOn: html
	self batchSize < self cache size ifTrue: [
		html tableRow: [
			html cssClass: 'batch'; attributeAt: 'colspan' put: self columns size.
			html tableData: [
				self showBatchFirstLast
					ifTrue: [ self renderBatchFirstOn: html ].
				self showBatchPreviousNext
					ifTrue: [ self renderBatchPreviousOn: html ].
				self showBatchPages
					ifTrue: [ self renderBatchItemsOn: html ].
				self showBatchPreviousNext
					ifTrue: [ self renderBatchNextOn: html ].
				self showBatchFirstLast
					ifTrue: [ self renderBatchLastOn: html ] ] ] ].! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 3/21/2005 16:31'!
renderTableBodyOn: html
	self visible isEmpty 
		ifTrue: [
			html cssClass: 'empty'.
			html tableRow: [
				html attributeAt: #colspan put: self columns size.
				html tableData: [
					html render: self tableEmpty ] ] ]
		ifFalse: [
			self visible withIndexDo: [ :row :index |
				html cssClass: (self rowStyleForNumber: index).
				html tableRow: [
					self columns do: [ :col |
						col 
							renderCell: (col valueFor: row) 
							index: index on: html ] ] ] ].! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 3/21/2005 16:31'!
renderTableCaptionOn: html
	html tag: 'caption' do: self tableCaption.! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 3/21/2005 16:31'!
renderTableFootOn: html
	html tableRow: [
		self columns do: [ :each |
			each renderFootCellOn: html ] ].! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 3/21/2005 16:31'!
renderTableHeadOn: html
	html tableRow: [
		self columns do: [ :each |
			each renderHeadCellOn: html ] ].! !

!MAReport methodsFor: 'rendering' stamp: 'lr 3/21/2005 16:33'!
renderTableOn: html
	self showCaption
		ifTrue: [ self renderTableCaptionOn: html ].
	self showSummary
		ifTrue: [ self renderTableSummaryOn: html ].
	html tag: 'thead' do: [
		self showHeader
			ifTrue: [ self renderTableHeadOn: html ] ].
	html tag: 'tbody' do: [
		self showBody 
			ifTrue: [ self renderTableBodyOn: html ] ].
	html tag: 'tfoot' do: [
		self showFooter
			ifTrue: [ self renderTableFootOn: html ].
		self showBatch
			ifTrue: [ self renderTableBatchOn: html ] ].! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 3/21/2005 16:31'!
renderTableSummaryOn: html
	html tag: 'summary' do: self tableSummary.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:42'!
rowFilter
	^self backtrackedAt: #rowFilter ifAbsentPut: [ self defaultRowFilter ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:37'!
rowFilter: aBlock
	self backtrackedAt: #rowFilter put: aBlock.
	self refresh.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:43'!
rowPeriod
	^self propertyAt: #rowPeriod ifAbsentPut: [ self defaultRowPeriod ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:37'!
rowPeriod: aNumber
	self propertyAt: #rowPeriod put: aNumber.! !

!MAReport methodsFor: 'private' stamp: 'lr 3/21/2005 16:30'!
rowStyleForNumber: aNumber
	^self rowStyles 
		at: ((aNumber - 1 // self rowPeriod) \\ self rowStyles size) + 1
		ifAbsent: [ String new ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:43'!
rowStyles
	^self propertyAt: #rowStyles ifAbsentPut: [ self defaultRowStyles ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:37'!
rowStyles: aCollection
	self propertyAt: #rowStyles put: aCollection.! !

!MAReport methodsFor: 'accessing' stamp: 'lr 3/21/2005 16:21'!
rows
	"Return the rows of the receiver."

	rows isNil
		ifTrue: [ self rows: Array new ].
	^rows.! !

!MAReport methodsFor: 'accessing' stamp: 'lr 3/23/2005 17:07'!
rows: aCollection
	"Set the rows of the receiver."
	
	self rows = aCollection ifFalse: [
		rows := aCollection.
		self refresh ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:43'!
showBatch
	^self propertyAt: #showBatch ifAbsentPut: [ self defaultShowBatch ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:38'!
showBatch: aBoolean
	self propertyAt: #showBatch put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:43'!
showBatchFirstLast
	^self propertyAt: #showBatchFirstLast ifAbsentPut: [ self defaultShowBatchFirstLast ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:38'!
showBatchFirstLast: aBoolean
	self propertyAt: #showBatchFirstLast put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:43'!
showBatchPages
	^self propertyAt: #showBatchPages ifAbsentPut: [ self defaultShowBatchPages ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:38'!
showBatchPages: aBoolean
	self propertyAt: #showBatchPages put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:43'!
showBatchPreviousNext
	^self propertyAt: #showBatchPreviousNext ifAbsentPut: [ self defaultShowBatchPreviousNext ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:38'!
showBatchPreviousNext: aBoolean
	self propertyAt: #showBatchPreviousNext put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:43'!
showBody
	^self propertyAt: #showBody ifAbsentPut: [ self defaultShowBody ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:38'!
showBody: aBoolean
	self propertyAt: #showBody put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:43'!
showCaption
	^self propertyAt: #showCaption ifAbsentPut: [ self defaultShowCaption ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:38'!
showCaption: aBoolean
	self propertyAt: #showCaption put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:43'!
showFooter
	^self propertyAt: #showFooter ifAbsentPut: [ self defaultShowFooter ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:38'!
showFooter: aBoolean
	self propertyAt: #showFooter put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:43'!
showHeader
	^self propertyAt: #showHeader ifAbsentPut: [ self defaultShowHeader ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:39'!
showHeader: aBoolean
	self propertyAt: #showHeader put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:43'!
showSummary
	^self propertyAt: #showSummary ifAbsentPut: [ self defaultShowSummary ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:39'!
showSummary: aBoolean
	self propertyAt: #showSummary put: aBoolean.! !

!MAReport methodsFor: 'actions' stamp: 'lr 3/21/2005 16:34'!
sort: aColumn
	aColumn = self sortColumn
		ifTrue: [
			self sortReversed
				ifFalse: [ self sortReversed: true ]
				ifTrue: [ self sortColumn: nil; sortReversed: false ] ]
		ifFalse: [ self sortColumn: aColumn; sortReversed: false ].
	self refresh.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:44'!
sortArrowDown
	^self propertyAt: #sortArrowDown ifAbsentPut: [ self defaultSortArrowDown ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:39'!
sortArrowDown: aForm
	self propertyAt: #sortArrowDown put: aForm.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:44'!
sortArrowUp
	^self propertyAt: #sortArrowUp ifAbsentPut: [ self defaultSortArrowUp ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:39'!
sortArrowUp: aForm
	self propertyAt: #sortArrowUp put: aForm.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:44'!
sortColumn
	^self backtrackedAt: #sortColumn ifAbsentPut: [ self defaultSortColumn ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:39'!
sortColumn: aColumn
	self backtrackedAt: #sortColumn put: aColumn.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:44'!
sortEnabled
	^self propertyAt: #sortEnabled ifAbsentPut: [ self defaultSortEnabled ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:39'!
sortEnabled: aBoolean
	self propertyAt: #sortEnabled put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:44'!
sortReversed
	^self backtrackedAt: #sortReversed ifAbsentPut: [ self defaultSortReversed ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:40'!
sortReversed: aBoolean
	self backtrackedAt: #sortReversed put: aBoolean.! !

!MAReport methodsFor: 'private' stamp: 'lr 3/21/2005 16:30'!
sortRows: aCollection
	^self isSorted
		ifFalse: [ aCollection ]
		ifTrue: [ self sortColumn sortRows: aCollection ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:44'!
tableCaption
	^self propertyAt: #tableCaption ifAbsentPut: [ self defaultTableCaption ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:40'!
tableCaption: aString
	self propertyAt: #tableCaption put: aString.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:44'!
tableEmpty
	^self propertyAt: #tableEmpty ifAbsentPut: [ self defaultTableEmpty ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:40'!
tableEmpty: aString
	self propertyAt: #tableEmpty put: aString.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:44'!
tableSummary
	^self propertyAt: #tableSummary ifAbsentPut: [ self defaultTableSummary ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:40'!
tableSummary: aString
	self propertyAt: #tableSummary put: aString.! !

!MAReport methodsFor: 'accessing-readonly' stamp: 'lr 3/21/2005 16:34'!
visible
	^self showBatch
		ifFalse: [ self cache ]
		ifTrue: [
			self cache
				copyFrom: self batchStartIndex
				to: self batchEndIndex ].! !

!MATextDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:37'!
defaultComponentClass
	^MATextAreaComponent! !

!MATableDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/15/2005 09:00'!
defaultComponentClass
	^MATableComponent! !

!MAReportContainer class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/24/2005 15:00'!
defaultComponentClass
	^MAReportComponent! !

!MAOptionsDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/29/2005 20:30'!
defaultComponentClass
	^MASelectListComponent! !

!MAStringDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:36'!
defaultComponentClass
	^MATextInputComponent! !

!MAPasswordDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:37'!
defaultComponentClass
	^MATextPasswordComponent! !
